; 

    .486                                ; create 32 bit code
    .model flat, stdcall                ; 32 bit memory model
    option casemap :none                ; case sensitive
  
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\user32.inc
    include \masm32\include\kernel32.inc

    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\user32.lib
    includelib \masm32\lib\kernel32.lib

    .data?

    .data

    .code _TEXT

; Copy this
; 
; Conversion from ASCII string to DECimal value DWORD sized, I stake to size and non-standard code, not speed in this proc
; input - pointer to string
; returned number - in eax
; error checking: none, the programmer must be sure, what passed string is the number, not
; "random" bytes, or zero-length string
;
; Special Notes: 
; If your version of the ml.exe don't support 16-byte alignment, comment "align 16" lines.
; This proc *support* both signed and unsigned numbers, atodw - not support signed numbers in 
; current state: 20.07.2010 (bugged).
; To define signed negative number - set the minus char before number ("-5", for example)
; Positive numbers must be without sign char (i.e. without "+" char, simlpe "5", for example).
;
; This proc be written by me, for good mood, and only :) I use non-standard "stack frame", and maximum unified
; algo to converd both signed and unsigned string-numbers.
;
; But, if change some things, this code be faster and smaller, than atodw. Maybe, I change it...
;
; On my machine, 100,000,000 (100 millions) times of conversion take ~3850 milliseconds,
; and, the same value ^^^ of conversion times in atodw proc take ~3700 milliseconds.
; Size of Axhex2dw - 38 bytes, size of hex2dw - 54 bytes.
;
;	Copyright (c) Antariy
;
    .code _TEXT

option prologue:none
option epilogue:none


align 16
Axa2l proc lpszString:DWORD

    pop ecx
    pop edx
    push ecx

    push edi

    xor edi,edi

        xor eax,eax
        movzx ecx,byte ptr [edx]
        cmp cl,'-'
        jnz @preloop
        inc edx
        dec edi

        @mainloop:
        mov cl, byte ptr [edx]
	@preloop:
        jecxz @done
        lea eax,[eax+eax*4]
        inc edx
        lea eax,[eax*2+ecx-'0']
        jmp @mainloop


    @done:        


    add eax,edi
    xor eax,edi

    pop edi

    ret

Axa2l endp
option prologue:PrologueDef
option epilogue:EpilogueDef
; 
; End of Copying




; 
; The testing prog
.data
align 16
thestring   db  "1234543210",0
even
aformat     db  "%d",0 ; NOTE!!! Number be converted right, but I specially use signed output in messagebox
                                    ; for showing, what Axa2l support signed numbers,
                                    ; for example change thestring  to "-105", and see results.


.code _TEXT

align 16
start proc

invoke GetCurrentProcess

push ebx

invoke SetPriorityClass,eax,REALTIME_PRIORITY_CLASS
invoke Sleep,0

invoke Axa2l,offset thestring
add esp,-1028
mov ebx,esp
push eax
push offset aformat
push ebx
call wsprintf
push MB_ICONINFORMATION
call @F
db  "Out of Axa2l conversion",0
@@:
push ebx
push 0
call MessageBox

invoke atodw,offset thestring
push eax
push offset aformat
push ebx
call wsprintf
push MB_ICONINFORMATION
call @F
db  "Out of atodw conversion",0
@@:
push ebx
push 0
call MessageBox
;invoke ExitProcess,0

;rdtsc
invoke GetTickCount
neg eax
push eax
mov edi,10000000
align 16
@loop1:
REPEAT 10
invoke Axa2l,offset thestring
ENDM
dec edi
jnz @loop1

invoke GetTickCount
add [esp],eax

push offset aformat
push ebx
call wsprintf

push MB_ICONINFORMATION
call @F
db "Axa2l Time",0
@@:
push ebx
push 0
call MessageBox

invoke GetTickCount
neg eax
push eax
mov edi,10000000
align 16
@loop2:
REPEAT 10
invoke atodw,offset thestring
ENDM
dec edi
jnz @loop2

invoke GetTickCount
add [esp],eax
push offset aformat
push ebx
call wsprintf

push MB_ICONINFORMATION
call @F
db "atodw Time",0
@@:
push ebx
push 0
call MessageBox


add esp,1028+12+12+12+12

pop ebx
@done:
 ret

start endp


end start
